
-- ************************* * * * * * * * * * * *************************
-- ***************** * * * * * >>> Author <<< * * * * * ******************
-- ************************* * * * * * * * * * * *************************
-- ******************** * * * * * Crackpot * * * * * *********************
-- *********************** * * * * * on * * * * * ************************
-- ***************** * * * * * Kul Tiras (EU) * * * * * ******************
-- ************************* * * * * * * * * * * *************************

-- ************************* * * * * * * * * * * *************************
-- ***** * * * * * Here is the option for Answering Machine * * * * * ****
-- ************************* * * * * * * * * * * *************************

-- The version of the addon
AM_Version = GetAddOnMetadata("Answering_Machine","Version")

-- ************************* * * * * * * * * * * *************************
-- *********************** * * * * * ToDo * * * * * **********************
-- ************************* * * * * * * * * * * *************************

-- * Make it possible to reply with click on name - Done
-- * Make is so if we timeout logout then we save all unread whispers - Not startet yet
-- * Find out of what will happen if it's a Game Master there whisper you while your AFK - Not startet yet
-- * Find out of is it possible to "change flag" while AFK and what will happen - Not startet yet
-- * Find a way to reply with out leaving AFK - Not startet yet
-- * Add class color to name - Will not be added
-- * Get someone to check spelling -  Not startet yet
-- * Why do it play in random order ? - Done
-- * Record all AH messages - Done, i hope

-- ************************* * * * * * * * * * * *************************
-- ********** * * * * * Register events and make frame * * * * * *********
-- ************************* * * * * * * * * * * *************************

-- Create a frame to use
local f = CreateFrame("Frame")

-- Register all the events we want to use
f:RegisterEvent("ADDON_LOADED") -- Fires when a addon is loaded.
f:RegisterEvent("PLAYER_FLAGS_CHANGED") -- Fires when the flag change (AFK, DND, etc).
-- f:RegisterEvent("PLAYER_LOGOUT") -- Fires immediately before the player is logged out of the game.
f:RegisterEvent("CHAT_MSG_WHISPER") -- Fires when someone whisper to you.
f:RegisterEvent("CHAT_MSG_BN_WHISPER") -- Fires when someone with BattleNet ID whisper to you.
f:RegisterEvent("CHAT_MSG_SYSTEM") -- 

-- ************************* * * * * * * * * * * *************************
-- ********************** * * * * * OnEvent * * * * * ********************
-- ************************* * * * * * * * * * * *************************

-- Event handler
f:SetScript("OnEvent", function(self, event, arg1, arg2, agr3, ...)
    -- Find out of what event it is
    if (event == "ADDON_LOADED") then
        if (arg1:lower() == "answering_machine") then
            print("|cffFFFF00"..AM_LOAD1.. "|r|cffFF80FFv."..AM_Version.. "|r|cffFFFF00"..AM_LOAD2.."|r");
            f:UnregisterEvent("ADDON_LOADED");
        else
            return
        end
-- ************************* * * * * * * * * * * *************************
    elseif (event == "PLAYER_FLAGS_CHANGED") then
        -- Check to see if we are AFK and have to record.
        if (UnitIsAFK("player")) then
            if (AM_Status ~= "on") then
		AM_WhisperLog = {}
                AM_AuthorLog = {}
                AM_AH_Log = {}
                AM_Status = "on";
                AM_Count = 0;
                print ("|cffFFFF00" ..AM_SPLIT.. "|r");
                print ("|cffFFFF00" ..AM_ON1.. "|r");
                print ("|cffFFFF00" ..AM_ON2.. "|r");
                print ("|cffFFFF00" ..AM_SPLIT.. "|r");
            end
-- ************************* * * * * * * * * * * *************************
        -- Check to see if we are not AFK and have to play the recorded
        elseif ((not UnitIsAFK("player")) and (AM_Status == "on")) then
            AM_Play()
        end
-- ************************* * * * * * * * * * * *************************
    elseif (event == "CHAT_MSG_WHISPER") or (event == "CHAT_MSG_BN_WHISPER") then
        -- Check to see if we are AFK
        if (UnitIsAFK("player")) then
            AM_Record(arg1, arg2)
        end
-- ************************* * * * * * * * * * * *************************
    elseif event == "CHAT_MSG_SYSTEM" then
        -- Are we afk ?
        if (UnitIsAFK("player")) then
            -- Do we want to record AH messages ?
            -- if () then
                -- Find what we need to record
                if strfind(arg1, AM_AH_SOLD) then
                    AM_AH_Record(arg1)
                elseif strfind(arg1, AM_AH_EXPIRE) then
                    AM_AH_Record(arg1)
                elseif strfind(arg1, AM_AH_OUTBID) then
                    AM_AH_Record(arg1)
                elseif strfind(arg1, AM_AH_WON) then
                    AM_AH_Record(arg1)
                elseif strfind(arg1, AM_AH_BID) then
                    AM_AH_Record(arg1)
                end
            -- end            
        end
-- ************************* * * * * * * * * * * *************************
    elseif (event == "PLAYER_LOGOUT") then
        -- Save all unread whispers until we log in again.
        return
    end
end)

-- ************************* * * * * * * * * * * *************************
-- ************ * * * * * Start recording whispers * * * * * *************
-- ************************* * * * * * * * * * * *************************

function AM_Record(arg1, arg2)
    -- Check to see if we are AFK
    if (UnitIsAFK("player")) then
        -- A check to make sure that AM_Count is not = nil
        if (AM_Count == nil) then
            AM_Count = 0;
        end
        -- Count to show how many new messages we have and put in order in the table
        AM_Count = AM_Count + 1;
        -- Get the author
        AM_Author = arg2
        -- Get the whisper and color it
        AM_Whisper = "|cffFF80FF" ..arg1.. "|r"
        -- Put the author in a table
        AM_AuthorLog[AM_Count] = AM_Author
        -- Put the whisper in a table
        AM_WhisperLog[AM_Count] = AM_Whisper
        -- What language do we speek (Horde / Alliance)
        AM_language = GetDefaultLanguage(player);
        -- Reply to the one there is whispering you.
        -- SendChatMessage(AM_AWAY_MSG, "WHISPER", AM_language, arg2);
    end
end

-- ************************* * * * * * * * * * * *************************
-- *************** * * * * * Start recording AH * * * * * ****************
-- ************************* * * * * * * * * * * *************************

function AM_AH_Record(arg1)
    -- Check to see if we are AFK
    if (UnitIsAFK("player")) then
        -- Check that AM_AH_Count is not nil
        if (AM_AH_Count == nil) then
            AM_AH_Count = 0;
        end
        -- Count all AH messages
        AM_AH_Count = AM_AH_Count + 1
        -- Get the AH message
        AM_AH_Message = arg1
        -- Put it in a table
        AM_AH_Log[AM_AH_Count] = AM_AH_Message
    end
end

-- ************************* * * * * * * * * * * *************************
-- *********** * * * * * Start playback of whispers * * * * * ************
-- ************************* * * * * * * * * * * *************************

function AM_Play()
    print ("|cffFFFF00" ..AM_SPLIT.. "|r");
    print ("|cffFFFF00" ..AM_OFF.. "|r");
     -- Did we get any messages while we was AFK ?
    if (AM_Count == 0) then
        print ("|cffFF80FF" ..AM_NO_MESSAGES.. "|r");
    else
        -- Is it 1 or more we got (for the spelling)
        if (AM_Count == 1) then
            print ("|cffFF80FF" ..AM_1_MESSAGE.. "|r");
        else
            print ("|cffFF80FF" ..AM_1PLUS_MESSAGES1 .. AM_Count .. AM_1PLUS_MESSAGES2.. "|r");
        end
        -- Make the loop and print every message that we have missed
        for i=1,#(AM_AuthorLog) do
            print ("[|Hplayer:"..AM_AuthorLog[i].."|h"..AM_AuthorLog[i].."|h]: "..AM_WhisperLog[i])
        end
    end
    -- Reset counter and turn AM_Status off
    AM_Count = 0;
    AM_Status = "off";
    print ("|cffFFFF00" ..AM_SPLIT.. "|r");
    -- Do we play AH messages ?
    -- if () then
        AM_AH_Play()
    -- end
end

-- ************************* * * * * * * * * * * *************************
-- ************** * * * * * Start playback of AH * * * * * ***************
-- ************************* * * * * * * * * * * *************************

function AM_AH_Play()
    -- Did we miss any AH message ?
    if (AM_AH_Count == 0) or (AM_AH_Count == nil) then
        print ("|cffFFFF00" ..AM_AH_NONE.. "|r")
    else
        -- Is it 1 or more we got (for the spelling)
        if (AM_AH_Count == 1) then
            print ("|cffFFFF00" ..AM_AH_1_MESSAGE.. "|r");
        else
            print ("|cffFFFF00" ..AM_AH_1PLUS_MESSAGES1 .. AM_AH_Count .. AM_AH_1PLUS_MESSAGES2.. "|r");
        end
        for i=1,#(AM_AuthorLog) do
            print ("|cffFFFF00" ..AM_AH_Message[i].. "|r")
        end
    end
    -- Reset counter
    AM_AH_Count = 0;
    print ("|cffFFFF00" ..AM_SPLIT.. "|r");
end